=== modified file 'Makefile'
--- Makefile	2012-06-01 18:39:03 +0000
+++ Makefile	2012-06-17 22:26:40 +0000
@@ -23,7 +23,7 @@
 OPTIMIZE=-Os
 LANGUAGE=-std=gnu99
 htmldir=man
-version=1.5.5
+version=1.6.0
 SED=sed
 
 USER=$(firstword $(subst :, ,$(shell getent passwd _mandos || getent passwd nobody || echo 65534)))
@@ -68,13 +68,13 @@
 	--param make.single.year.ranges		1 \
 	--param man.output.quietly		1 \
 	--param man.authors.section.enabled	0 \
-	 /usr/share/xml/docbook/stylesheet/nwalsh/manpages/docbook.xsl \
+	/usr/share/xml/docbook/stylesheet/nwalsh/manpages/docbook.xsl \
 	$(notdir $<); \
 	$(MANPOST) $(notdir $@);\
-	if locale --all | grep --regexp='^en_US\.utf8$$' && type man \
-	2>/dev/null; then LANG=en_US.UTF-8 MANWIDTH=80 man \
-	--warnings --encoding=UTF-8 --local-file $(notdir $@); fi \
-	>/dev/null)
+	if locale --all 2>/dev/null | grep --regexp='^en_US\.utf8$$' \
+	&& type man 2>/dev/null; then LANG=en_US.UTF-8 MANWIDTH=80 \
+	man --warnings --encoding=UTF-8 --local-file $(notdir $@); \
+	fi >/dev/null)
 # DocBook-to-man post-processing to fix a '\n' escape bug
 MANPOST=$(SED) --in-place --expression='s,\\\\en,\\en,g;s,\\n,\\en,g'
 

=== modified file 'NEWS'
--- NEWS	2012-06-01 18:39:03 +0000
+++ NEWS	2012-06-17 22:26:40 +0000
@@ -1,6 +1,16 @@
 This NEWS file records noteworthy changes, very tersely.
 See the manual for detailed information.
 
+Version 1.6.0 (2012-06-18)
+* Server
+** Takes new --foreground option
+** Init script supports new "status" action.
+* Client
+** Now uses all interfaces by default; the --interface option can
+   still be used to restrict it, and the argument to --interface (as
+   well as the $DEVICE environment variable for the network hooks) is
+   now a comma-separated list of interfaces to use.
+
 Version 1.5.5 (2012-06-01)
 * Server
 ** Server takes new --socket option

=== modified file 'TODO'
--- TODO	2012-05-26 22:21:17 +0000
+++ TODO	2012-06-17 14:55:31 +0000
@@ -5,13 +5,12 @@
 * mandos-applet
 
 * mandos-client
-** TODO [#A] Wireless network hook
 ** TODO [#B] Use capabilities instead of seteuid().
 ** TODO [#B] Use struct sockaddr_storage instead of a union
 ** TODO [#B] Use getaddrinfo(hints=AI_NUMERICHOST) instead of inet_pton()
 ** TODO [#B] Use getnameinfo(serv=NULL, NI_NUMERICHOST) instead of inet_ntop()
 ** TODO [#B] Prefer /run/tmp over /tmp, if it exists
-** TODO [#B] Use in_port_t instead of uint16_t for port numbers.
+** TODO [#C] Make start_mandos_communication() take "struct server".
 
 * splashy
 ** TODO [#B] use scandir(3) instead of readdir(3)
@@ -19,7 +18,6 @@
 * usplash (Deprecated)
 ** TODO [#A] Make it work again
 ** TODO [#B] use scandir(3) instead of readdir(3)
-** TODO Use [[info:libc:Argz%20Functions][argz_extract]]
 
 * askpass-fifo
 ** TODO [#B] Drop privileges after opening FIFO.
@@ -33,7 +31,7 @@
 
 * plugin-runner
 ** TODO handle printing for errors for plugins
-*** Hook up stderr of plugins, buffer them, and prepend mandos pluig [plugin name]
+*** Hook up stderr of plugins, buffer them, and prepend "Mandos Plugin [plugin name]"
 ** TODO [#B] use scandir(3) instead of readdir(3)
 ** TODO [#C] use same file name rules as run-parts(8)
 ** kernel command line option for debug info
@@ -46,8 +44,6 @@
 ** TODO [#C] config for TXT record
 ** TODO Log level dbus option
    SetLogLevel D-Bus call
-** TODO Implement --foreground						  :BUGS:
-   [[info:standards:Option%20Table][Table of Long Options]]
 ** TODO [#C] DBusServiceObjectUsingSuper
 ** TODO [#B] Global enable/disable flag
 ** TODO [#B] By-client countdown on number of secrets given

=== modified file 'common.ent'
--- common.ent	2012-06-01 18:39:03 +0000
+++ common.ent	2012-06-17 22:26:40 +0000
@@ -1,3 +1,3 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!-- Edited by Makefile -->
-<!ENTITY version "1.5.5">
+<!ENTITY version "1.6.0">

=== modified file 'debian/changelog'
--- debian/changelog	2012-06-01 18:39:03 +0000
+++ debian/changelog	2012-06-17 22:26:40 +0000
@@ -1,3 +1,18 @@
+mandos (1.6.0-1) unstable; urgency=low
+
+  * New upstream release.
+  * debian/copyright (Copyright): Join the two lines to a single line.
+  * debian/mandos-client.README.Debian: Update to refer to the new
+    location of the example network hooks, and the new feature of using
+    all network interfaces.
+  * debian/mandos-client.docs (network-hooks.d): Removed.
+  * debian/mandos-client.examples (network-hooks.d): New.
+  * debian/rules (binary-common): Added "dh_installexamples".
+    (binary-common/dh_fixperms): Exclude new location of
+    "network-hooks.d".
+
+ -- Teddy Hogeborn <teddy@recompile.se>  Mon, 18 Jun 2012 00:15:23 +0200
+
 mandos (1.5.5-1) unstable; urgency=low
 
   * New upstream release.

=== modified file 'debian/mandos-client.README.Debian'
--- debian/mandos-client.README.Debian	2012-06-01 21:48:12 +0000
+++ debian/mandos-client.README.Debian	2012-06-16 19:30:08 +0000
@@ -32,9 +32,9 @@
 
 * Specifying a Client Network Interface
   
-  At boot time the network interface to use will by default be
-  automatically detected.  If this should result in an incorrect
-  interface, edit the DEVICE setting in the
+  At boot time the network interfaces to use will by default be
+  automatically detected.  If this should result in incorrect
+  interfaces, edit the DEVICE setting in the
   "/etc/initramfs-tools/initramfs.conf" file.  (The default setting is
   empty, meaning it will autodetect the interface.)  *If* the DEVICE
   setting is changed, it will be necessary to update the initrd image
@@ -42,18 +42,18 @@
   
 	update-initramfs -k all -u
   
-  The device can be overridden at boot time on the Linux kernel
+  The device can also be overridden at boot time on the Linux kernel
   command line using the sixth colon-separated field of the "ip="
   option; for exact syntax, read the documentation in the file
   "/usr/share/doc/linux-doc-*/Documentation/filesystems/nfsroot.txt",
   available in the "linux-doc-*" package.
   
-  Note that since this network interface is used in the initial RAM
-  disk environment, the network interface *must* exist at that stage.
-  Thus, the interface can *not* be a pseudo-interface such as "br0" or
-  "tun0"; instead, only real interface (such as "eth0") can be used.
+  Note that since the network interfaces are used in the initial RAM
+  disk environment, the network interfaces *must* exist at that stage.
+  Thus, an interface can *not* be a pseudo-interface such as "br0" or
+  "tun0"; instead, only real interfaces (such as "eth0") can be used.
   This can be overcome by writing a "network hook" program to create
-  the interface (see mandos-client(8mandos)) and placing it in
+  an interface (see mandos-client(8mandos)) and placing it in
   "/etc/mandos/network-hooks.d", from where it will be copied into the
   initial RAM disk.  Example network hook scripts can be found in
   "/usr/share/doc/mandos-client/examples/network-hooks.d".
@@ -90,4 +90,4 @@
   work, "--options-for=mandos-client:--connect=<ADDRESS>:<PORT>" needs
   to be manually added to the file "/etc/mandos/plugin-runner.conf".
 
- -- Teddy Hogeborn <teddy@recompile.se>, Fri,  1 Jun 2012 23:46:13 +0200
+ -- Teddy Hogeborn <teddy@recompile.se>, Sat, 16 Jun 2012 13:09:58 +0200

=== modified file 'mandos'
--- mandos	2012-06-01 18:39:03 +0000
+++ mandos	2012-06-17 22:26:40 +0000
@@ -88,7 +88,7 @@
     except ImportError:
         SO_BINDTODEVICE = None
 
-version = "1.5.5"
+version = "1.6.0"
 stored_state_file = "clients.pickle"
 
 logger = logging.getLogger()
@@ -1948,21 +1948,18 @@
                 try:
                     self.socket.setsockopt(socket.SOL_SOCKET,
                                            SO_BINDTODEVICE,
-                                           str(self.interface
-                                               + '\0'))
+                                           str(self.interface + '\0'))
                 except socket.error as error:
                     if error.errno == errno.EPERM:
-                        logger.error("No permission to"
-                                     " bind to interface %s",
-                                     self.interface)
+                        logger.error("No permission to bind to"
+                                     " interface %s", self.interface)
                     elif error.errno == errno.ENOPROTOOPT:
                         logger.error("SO_BINDTODEVICE not available;"
                                      " cannot bind to interface %s",
                                      self.interface)
                     elif error.errno == errno.ENODEV:
-                        logger.error("Interface %s does not"
-                                     " exist, cannot bind",
-                                     self.interface)
+                        logger.error("Interface %s does not exist,"
+                                     " cannot bind", self.interface)
                     else:
                         raise
         # Only bind(2) the socket if we really need to.
@@ -2201,6 +2198,8 @@
                         " socket to use instead of creating one")
     parser.add_argument("--statedir", metavar="DIR",
                         help="Directory to save/restore state in")
+    parser.add_argument("--foreground", action="store_true",
+                        help="Run in foreground")
     
     options = parser.parse_args()
     
@@ -2222,7 +2221,8 @@
                         "debuglevel": "",
                         "restore": "True",
                         "socket": "",
-                        "statedir": "/var/lib/mandos"
+                        "statedir": "/var/lib/mandos",
+                        "foreground": "False",
                         }
     
     # Parse config file for server-global settings
@@ -2233,7 +2233,7 @@
     # Convert the SafeConfigParser object to a dict
     server_settings = server_config.defaults()
     # Use the appropriate methods on the non-string config options
-    for option in ("debug", "use_dbus", "use_ipv6"):
+    for option in ("debug", "use_dbus", "use_ipv6", "foreground"):
         server_settings[option] = server_config.getboolean("DEFAULT",
                                                            option)
     if server_settings["port"]:
@@ -2255,7 +2255,7 @@
     for option in ("interface", "address", "port", "debug",
                    "priority", "servicename", "configdir",
                    "use_dbus", "use_ipv6", "debuglevel", "restore",
-                   "statedir", "socket"):
+                   "statedir", "socket", "foreground"):
         value = getattr(options, option)
         if value is not None:
             server_settings[option] = value
@@ -2264,6 +2264,9 @@
     for option in server_settings.keys():
         if type(server_settings[option]) is str:
             server_settings[option] = unicode(server_settings[option])
+    # Debug implies foreground
+    if server_settings["debug"]:
+        server_settings["foreground"] = True
     # Now we have our good server settings in "server_settings"
     
     ##################################################################
@@ -2275,6 +2278,7 @@
     use_ipv6 = server_settings["use_ipv6"]
     stored_state_path = os.path.join(server_settings["statedir"],
                                      stored_state_file)
+    foreground = server_settings["foreground"]
     
     if debug:
         initlogger(debug, logging.DEBUG)
@@ -2312,8 +2316,9 @@
                               use_dbus=use_dbus,
                               socketfd=(server_settings["socket"]
                                         or None))
-    if not debug:
+    if not foreground:
         pidfilename = "/var/run/mandos.pid"
+        pidfile = None
         try:
             pidfile = open(pidfilename, "w")
         except IOError as e:
@@ -2358,7 +2363,7 @@
             os.close(null)
     
     # Need to fork before connecting to D-Bus
-    if not debug:
+    if not foreground:
         # Close all input and output, do double fork, etc.
         daemon()
     
@@ -2497,18 +2502,16 @@
     if not tcp_server.clients:
         logger.warning("No clients defined")
     
-    if not debug:
-        try:
-            with pidfile:
-                pid = os.getpid()
-                pidfile.write(str(pid) + "\n".encode("utf-8"))
-            del pidfile
-        except IOError:
-            logger.error("Could not write to file %r with PID %d",
-                         pidfilename, pid)
-        except NameError:
-            # "pidfile" was never created
-            pass
+    if not foreground:
+        if pidfile is not None:
+            try:
+                with pidfile:
+                    pid = os.getpid()
+                    pidfile.write(str(pid) + "\n".encode("utf-8"))
+            except IOError:
+                logger.error("Could not write to file %r with PID %d",
+                             pidfilename, pid)
+        del pidfile
         del pidfilename
     
     signal.signal(signal.SIGHUP, lambda signum, frame: sys.exit())

=== modified file 'mandos-ctl'
--- mandos-ctl	2012-06-01 18:39:03 +0000
+++ mandos-ctl	2012-06-17 22:26:40 +0000
@@ -63,7 +63,7 @@
 server_path = "/"
 server_interface = domain + ".Mandos"
 client_interface = domain + ".Mandos.Client"
-version = "1.5.5"
+version = "1.6.0"
 
 def timedelta_to_milliseconds(td):
     """Convert a datetime.timedelta object to milliseconds"""

=== modified file 'mandos-keygen'
--- mandos-keygen	2012-06-01 18:39:03 +0000
+++ mandos-keygen	2012-06-17 22:26:40 +0000
@@ -21,7 +21,7 @@
 # Contact the authors at <mandos@recompile.se>.
 # 
 
-VERSION="1.5.5"
+VERSION="1.6.0"
 
 KEYDIR="/etc/keys/mandos"
 KEYTYPE=DSA

=== modified file 'mandos-monitor'
--- mandos-monitor	2012-06-01 18:39:03 +0000
+++ mandos-monitor	2012-06-17 22:26:40 +0000
@@ -55,7 +55,7 @@
 domain = 'se.recompile'
 server_interface = domain + '.Mandos'
 client_interface = domain + '.Mandos.Client'
-version = "1.5.5"
+version = "1.6.0"
 
 # Always run in monochrome mode
 urwid.curses_display.curses.has_colors = lambda : False

=== modified file 'mandos-options.xml'
--- mandos-options.xml	2012-05-26 22:21:17 +0000
+++ mandos-options.xml	2012-06-17 14:55:31 +0000
@@ -103,4 +103,11 @@
     default, the server will create a new network socket.
   </para>
   
+  <para id="foreground">
+    This option will make the server run in the foreground and not
+    write a PID file.  The default is to <emphasis>not</emphasis> run
+    in the foreground, except in <option>debug</option> mode, which
+    implies this option.
+  </para>
+  
 </section>

=== modified file 'mandos.conf'
--- mandos.conf	2011-11-26 22:22:20 +0000
+++ mandos.conf	2012-06-17 14:55:31 +0000
@@ -42,3 +42,6 @@
 
 # The directory where state is saved
 ;statedir = /var/lib/mandos
+
+# Whether to run in the foreground
+;foreground = False

=== modified file 'mandos.lsm'
--- mandos.lsm	2012-06-01 18:39:03 +0000
+++ mandos.lsm	2012-06-17 22:26:40 +0000
@@ -1,7 +1,7 @@
 Begin4
 Title:		Mandos
-Version:	1.5.5
-Entered-date:	2012-06-01
+Version:	1.6.0
+Entered-date:	2012-06-18
 Description:	The Mandos system allows computers to have encrypted
 root file systems and at the same time be capable of remote and/or
 unattended reboots.
@@ -12,9 +12,9 @@
 Maintained-by:	teddy@recompile.se (Teddy Hogeborn),
 		belorn@recompile.se (Björn Påhlsson)
 Primary-site: http://www.recompile.se/mandos
-	      148K mandos_1.5.5.orig.tar.gz
+	      150K mandos_1.6.0.orig.tar.gz
 Alternate-site: ftp://ftp.recompile.se/pub/mandos
-		148K mandos_1.5.5.orig.tar.gz
+		150K mandos_1.6.0.orig.tar.gz
 Platforms:	Requires GCC, GNU libC, Avahi, GnuPG, Python 2.6, and
 various other libraries.  While made for Debian GNU/Linux, it is
 probably portable to other distributions, but not other Unixes.

=== modified file 'mandos.xml'
--- mandos.xml	2012-05-26 22:21:17 +0000
+++ mandos.xml	2012-06-17 14:55:31 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 "http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos">
-<!ENTITY TIMESTAMP "2012-05-26">
+<!ENTITY TIMESTAMP "2012-06-17">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -103,6 +103,8 @@
       <sbr/>
       <arg><option>--socket
       <replaceable>FD</replaceable></option></arg>
+      <sbr/>
+      <arg><option>--foreground</option></arg>
     </cmdsynopsis>
     <cmdsynopsis>
       <command>&COMMANDNAME;</command>
@@ -311,6 +313,14 @@
 	</listitem>
       </varlistentry>
       
+      <varlistentry>
+	<term><option>--foreground</option></term>
+	<listitem>
+	  <xi:include href="mandos-options.xml"
+		      xpointer="foreground"/>
+	</listitem>
+      </varlistentry>
+      
     </variablelist>
   </refsect1>
   
@@ -561,9 +571,6 @@
       There is no fine-grained control over logging and debug output.
     </para>
     <para>
-      Debug mode is conflated with running in the foreground.
-    </para>
-    <para>
       This server does not check the expire time of clients’ OpenPGP
       keys.
     </para>

=== modified file 'plugins.d/mandos-client.c'
--- plugins.d/mandos-client.c	2012-06-13 22:06:57 +0000
+++ plugins.d/mandos-client.c	2012-06-17 12:23:31 +0000
@@ -61,7 +61,6 @@
 				 */
 #include <inttypes.h>		/* PRIu16, PRIdMAX, intmax_t,
 				   strtoimax() */
-#include <assert.h>		/* assert() */
 #include <errno.h>		/* perror(), errno,
 				   program_invocation_short_name */
 #include <time.h>		/* nanosleep(), time(), sleep() */
@@ -145,7 +144,7 @@
 /* Doubly linked list that need to be circularly linked when used */
 typedef struct server{
   const char *ip;
-  uint16_t port;
+  in_port_t port;
   AvahiIfIndex if_index;
   int af;
   struct timespec last_seen;
@@ -155,7 +154,6 @@
 
 /* Used for passing in values through the Avahi callback functions */
 typedef struct {
-  AvahiSimplePoll *simple_poll;
   AvahiServer *server;
   gnutls_certificate_credentials_t cred;
   unsigned int dh_bits;
@@ -163,13 +161,12 @@
   const char *priority;
   gpgme_ctx_t ctx;
   server *current_server;
+  char *interfaces;
+  size_t interfaces_size;
 } mandos_context;
 
-/* global context so signal handler can reach it*/
-mandos_context mc = { .simple_poll = NULL, .server = NULL,
-		      .dh_bits = 1024, .priority = "SECURE256"
-		      ":!CTYPE-X.509:+CTYPE-OPENPGP",
-		      .current_server = NULL };
+/* global so signal handler can reach it*/
+AvahiSimplePoll *simple_poll;
 
 sig_atomic_t quit_now = 0;
 int signal_received = 0;
@@ -211,8 +208,8 @@
 }
 
 /* Add server to set of servers to retry periodically */
-bool add_server(const char *ip, uint16_t port, AvahiIfIndex if_index,
-		int af){
+bool add_server(const char *ip, in_port_t port, AvahiIfIndex if_index,
+		int af, server **current_server){
   int ret;
   server *new_server = malloc(sizeof(server));
   if(new_server == NULL){
@@ -228,18 +225,18 @@
     return false;
   }
   /* Special case of first server */
-  if (mc.current_server == NULL){
+  if(*current_server == NULL){
     new_server->next = new_server;
     new_server->prev = new_server;
-    mc.current_server = new_server;
+    *current_server = new_server;
   /* Place the new server last in the list */
   } else {
-    new_server->next = mc.current_server;
-    new_server->prev = mc.current_server->prev;
+    new_server->next = *current_server;
+    new_server->prev = (*current_server)->prev;
     new_server->prev->next = new_server;
-    mc.current_server->prev = new_server;
+    (*current_server)->prev = new_server;
   }
-  ret = clock_gettime(CLOCK_MONOTONIC, &mc.current_server->last_seen);
+  ret = clock_gettime(CLOCK_MONOTONIC, &(*current_server)->last_seen);
   if(ret == -1){
     perror_plus("clock_gettime");
     return false;
@@ -251,11 +248,10 @@
  * Initialize GPGME.
  */
 static bool init_gpgme(const char *seckey, const char *pubkey,
-		       const char *tempdir){
+		       const char *tempdir, mandos_context *mc){
   gpgme_error_t rc;
   gpgme_engine_info_t engine_info;
   
-  
   /*
    * Helper function to insert pub and seckey to the engine keyring.
    */
@@ -277,7 +273,7 @@
       return false;
     }
     
-    rc = gpgme_op_import(mc.ctx, pgp_data);
+    rc = gpgme_op_import(mc->ctx, pgp_data);
     if(rc != GPG_ERR_NO_ERROR){
       fprintf_plus(stderr, "bad gpgme_op_import: %s: %s\n",
 		   gpgme_strsource(rc), gpgme_strerror(rc));
@@ -327,7 +323,7 @@
   }
   
   /* Create new GPGME "context" */
-  rc = gpgme_new(&(mc.ctx));
+  rc = gpgme_new(&(mc->ctx));
   if(rc != GPG_ERR_NO_ERROR){
     fprintf_plus(stderr, "Mandos plugin mandos-client: "
 		 "bad gpgme_new: %s: %s\n", gpgme_strsource(rc),
@@ -348,7 +344,8 @@
  */
 static ssize_t pgp_packet_decrypt(const char *cryptotext,
 				  size_t crypto_size,
-				  char **plaintext){
+				  char **plaintext,
+				  mandos_context *mc){
   gpgme_data_t dh_crypto, dh_plain;
   gpgme_error_t rc;
   ssize_t ret;
@@ -380,14 +377,14 @@
   
   /* Decrypt data from the cryptotext data buffer to the plaintext
      data buffer */
-  rc = gpgme_op_decrypt(mc.ctx, dh_crypto, dh_plain);
+  rc = gpgme_op_decrypt(mc->ctx, dh_crypto, dh_plain);
   if(rc != GPG_ERR_NO_ERROR){
     fprintf_plus(stderr, "bad gpgme_op_decrypt: %s: %s\n",
 		 gpgme_strsource(rc), gpgme_strerror(rc));
     plaintext_length = -1;
     if(debug){
       gpgme_decrypt_result_t result;
-      result = gpgme_op_decrypt_result(mc.ctx);
+      result = gpgme_op_decrypt_result(mc->ctx);
       if(result == NULL){
 	fprintf_plus(stderr, "gpgme_op_decrypt_result failed\n");
       } else {
@@ -471,8 +468,7 @@
 }
 
 static const char * safer_gnutls_strerror(int value){
-  const char *ret = gnutls_strerror(value); /* Spurious warning from
-					       -Wunreachable-code */
+  const char *ret = gnutls_strerror(value);
   if(ret == NULL)
     ret = "(unknown)";
   return ret;
@@ -485,7 +481,8 @@
 }
 
 static int init_gnutls_global(const char *pubkeyfilename,
-			      const char *seckeyfilename){
+			      const char *seckeyfilename,
+			      mandos_context *mc){
   int ret;
   
   if(debug){
@@ -508,7 +505,7 @@
   }
   
   /* OpenPGP credentials */
-  ret = gnutls_certificate_allocate_credentials(&mc.cred);
+  ret = gnutls_certificate_allocate_credentials(&mc->cred);
   if(ret != GNUTLS_E_SUCCESS){
     fprintf_plus(stderr, "GnuTLS memory error: %s\n",
 		 safer_gnutls_strerror(ret));
@@ -524,7 +521,7 @@
   }
   
   ret = gnutls_certificate_set_openpgp_key_file
-    (mc.cred, pubkeyfilename, seckeyfilename,
+    (mc->cred, pubkeyfilename, seckeyfilename,
      GNUTLS_OPENPGP_FMT_BASE64);
   if(ret != GNUTLS_E_SUCCESS){
     fprintf_plus(stderr,
@@ -536,33 +533,34 @@
   }
   
   /* GnuTLS server initialization */
-  ret = gnutls_dh_params_init(&mc.dh_params);
+  ret = gnutls_dh_params_init(&mc->dh_params);
   if(ret != GNUTLS_E_SUCCESS){
     fprintf_plus(stderr, "Error in GnuTLS DH parameter"
 		 " initialization: %s\n",
 		 safer_gnutls_strerror(ret));
     goto globalfail;
   }
-  ret = gnutls_dh_params_generate2(mc.dh_params, mc.dh_bits);
+  ret = gnutls_dh_params_generate2(mc->dh_params, mc->dh_bits);
   if(ret != GNUTLS_E_SUCCESS){
     fprintf_plus(stderr, "Error in GnuTLS prime generation: %s\n",
 		 safer_gnutls_strerror(ret));
     goto globalfail;
   }
   
-  gnutls_certificate_set_dh_params(mc.cred, mc.dh_params);
+  gnutls_certificate_set_dh_params(mc->cred, mc->dh_params);
   
   return 0;
   
  globalfail:
   
-  gnutls_certificate_free_credentials(mc.cred);
+  gnutls_certificate_free_credentials(mc->cred);
   gnutls_global_deinit();
-  gnutls_dh_params_deinit(mc.dh_params);
+  gnutls_dh_params_deinit(mc->dh_params);
   return -1;
 }
 
-static int init_gnutls_session(gnutls_session_t *session){
+static int init_gnutls_session(gnutls_session_t *session,
+			       mandos_context *mc){
   int ret;
   /* GnuTLS session creation */
   do {
@@ -580,7 +578,7 @@
   {
     const char *err;
     do {
-      ret = gnutls_priority_set_direct(*session, mc.priority, &err);
+      ret = gnutls_priority_set_direct(*session, mc->priority, &err);
       if(quit_now){
 	gnutls_deinit(*session);
 	return -1;
@@ -597,7 +595,7 @@
   
   do {
     ret = gnutls_credentials_set(*session, GNUTLS_CRD_CERTIFICATE,
-				 mc.cred);
+				 mc->cred);
     if(quit_now){
       gnutls_deinit(*session);
       return -1;
@@ -613,7 +611,7 @@
   /* ignore client certificate if any. */
   gnutls_certificate_server_set_request(*session, GNUTLS_CERT_IGNORE);
   
-  gnutls_dh_set_prime_bits(*session, mc.dh_bits);
+  gnutls_dh_set_prime_bits(*session, mc->dh_bits);
   
   return 0;
 }
@@ -623,9 +621,9 @@
 		      __attribute__((unused)) const char *txt){}
 
 /* Called when a Mandos server is found */
-static int start_mandos_communication(const char *ip, uint16_t port,
+static int start_mandos_communication(const char *ip, in_port_t port,
 				      AvahiIfIndex if_index,
-				      int af){
+				      int af, mandos_context *mc){
   int ret, tcp_sd = -1;
   ssize_t sret;
   union {
@@ -661,14 +659,46 @@
     return -1;
   }
   
-  ret = init_gnutls_session(&session);
+  /* If the interface is specified and we have a list of interfaces */
+  if(if_index != AVAHI_IF_UNSPEC and mc->interfaces != NULL){
+    /* Check if the interface is one of the interfaces we are using */
+    bool match = false;
+    {
+      char *interface = NULL;
+      while((interface=argz_next(mc->interfaces, mc->interfaces_size,
+				 interface))){
+	if(if_nametoindex(interface) == (unsigned int)if_index){
+	  match = true;
+	  break;
+	}
+      }
+    }
+    if(not match){
+      /* This interface does not match any in the list, so we don't
+	 connect to the server */
+      if(debug){
+	char interface[IF_NAMESIZE];
+	if(if_indextoname((unsigned int)if_index, interface) == NULL){
+	  perror_plus("if_indextoname");
+	} else {
+	  fprintf_plus(stderr, "Skipping server on non-used interface"
+		       " \"%s\"\n",
+		       if_indextoname((unsigned int)if_index,
+				      interface));
+	}
+      }
+      return -1;
+    }
+  }
+  
+  ret = init_gnutls_session(&session, mc);
   if(ret != 0){
     return -1;
   }
   
   if(debug){
     fprintf_plus(stderr, "Setting up a TCP connection to %s, port %"
-		 PRIu16 "\n", ip, port);
+		 PRIuMAX "\n", ip, (uintmax_t)port);
   }
   
   tcp_sd = socket(pf, SOCK_STREAM, 0);
@@ -705,10 +735,7 @@
     goto mandos_end;
   }
   if(af == AF_INET6){
-    to.in6.sin6_port = htons(port); /* Spurious warnings from
-				       -Wconversion and
-				       -Wunreachable-code */
-    
+    to.in6.sin6_port = htons(port);    
     if(IN6_IS_ADDR_LINKLOCAL /* Spurious warnings from */
        (&to.in6.sin6_addr)){ /* -Wstrict-aliasing=2 or lower and
 				-Wunreachable-code*/
@@ -738,12 +765,12 @@
       if(if_indextoname((unsigned int)if_index, interface) == NULL){
 	perror_plus("if_indextoname");
       } else {
-	fprintf_plus(stderr, "Connection to: %s%%%s, port %" PRIu16
-		     "\n", ip, interface, port);
+	fprintf_plus(stderr, "Connection to: %s%%%s, port %" PRIuMAX
+		     "\n", ip, interface, (uintmax_t)port);
       }
     } else {
-      fprintf_plus(stderr, "Connection to: %s, port %" PRIu16 "\n",
-		   ip, port);
+      fprintf_plus(stderr, "Connection to: %s, port %" PRIuMAX "\n",
+		   ip, (uintmax_t)port);
     }
     char addrstr[(INET_ADDRSTRLEN > INET6_ADDRSTRLEN) ?
 		 INET_ADDRSTRLEN : INET6_ADDRSTRLEN] = "";
@@ -942,7 +969,7 @@
   if(buffer_length > 0){
     ssize_t decrypted_buffer_size;
     decrypted_buffer_size = pgp_packet_decrypt(buffer, buffer_length,
-					       &decrypted_buffer);
+					       &decrypted_buffer, mc);
     if(decrypted_buffer_size >= 0){
       
       written = 0;
@@ -1009,8 +1036,10 @@
 			     AVAHI_GCC_UNUSED AvahiStringList *txt,
 			     AVAHI_GCC_UNUSED AvahiLookupResultFlags
 			     flags,
-			     AVAHI_GCC_UNUSED void* userdata){
-  assert(r);
+			     void* mc){
+  if(r == NULL){
+    return;
+  }
   
   /* Called whenever a service has been resolved successfully or
      timed out */
@@ -1025,7 +1054,8 @@
     fprintf_plus(stderr, "(Avahi Resolver) Failed to resolve service "
 		 "'%s' of type '%s' in domain '%s': %s\n", name, type,
 		 domain,
-		 avahi_strerror(avahi_server_errno(mc.server)));
+		 avahi_strerror(avahi_server_errno
+				(((mandos_context*)mc)->server)));
     break;
     
   case AVAHI_RESOLVER_FOUND:
@@ -1037,13 +1067,16 @@
 		     PRIdMAX ") on port %" PRIu16 "\n", name,
 		     host_name, ip, (intmax_t)interface, port);
       }
-      int ret = start_mandos_communication(ip, port, interface,
-					   avahi_proto_to_af(proto));
+      int ret = start_mandos_communication(ip, (in_port_t)port,
+					   interface,
+					   avahi_proto_to_af(proto),
+					   mc);
       if(ret == 0){
-	avahi_simple_poll_quit(mc.simple_poll);
+	avahi_simple_poll_quit(simple_poll);
       } else {
-	if(not add_server(ip, port, interface,
-			  avahi_proto_to_af(proto))){
+	if(not add_server(ip, (in_port_t)port, interface,
+			  avahi_proto_to_af(proto),
+			  &((mandos_context*)mc)->current_server)){
 	  fprintf_plus(stderr, "Failed to add server \"%s\" to server"
 		       " list\n", name);
 	}
@@ -1062,8 +1095,10 @@
 			    const char *domain,
 			    AVAHI_GCC_UNUSED AvahiLookupResultFlags
 			    flags,
-			    AVAHI_GCC_UNUSED void* userdata){
-  assert(b);
+			    void* mc){
+  if(b == NULL){
+    return;
+  }
   
   /* Called whenever a new services becomes available on the LAN or
      is removed from the LAN */
@@ -1077,8 +1112,9 @@
   case AVAHI_BROWSER_FAILURE:
     
     fprintf_plus(stderr, "(Avahi browser) %s\n",
-		 avahi_strerror(avahi_server_errno(mc.server)));
-    avahi_simple_poll_quit(mc.simple_poll);
+		 avahi_strerror(avahi_server_errno
+				(((mandos_context*)mc)->server)));
+    avahi_simple_poll_quit(simple_poll);
     return;
     
   case AVAHI_BROWSER_NEW:
@@ -1087,12 +1123,14 @@
        the callback function is called the Avahi server will free the
        resolver for us. */
     
-    if(avahi_s_service_resolver_new(mc.server, interface, protocol,
-				    name, type, domain, protocol, 0,
-				    resolve_callback, NULL) == NULL)
+    if(avahi_s_service_resolver_new(((mandos_context*)mc)->server,
+				    interface, protocol, name, type,
+				    domain, protocol, 0,
+				    resolve_callback, mc) == NULL)
       fprintf_plus(stderr, "Avahi: Failed to resolve service '%s':"
 		   " %s\n", name,
-		   avahi_strerror(avahi_server_errno(mc.server)));
+		   avahi_strerror(avahi_server_errno
+				  (((mandos_context*)mc)->server)));
     break;
     
   case AVAHI_BROWSER_REMOVE:
@@ -1117,8 +1155,8 @@
   signal_received = sig;
   int old_errno = errno;
   /* set main loop to exit */
-  if(mc.simple_poll != NULL){
-    avahi_simple_poll_quit(mc.simple_poll);
+  if(simple_poll != NULL){
+    avahi_simple_poll_quit(simple_poll);
   }
   errno = old_errno;
 }
@@ -1318,14 +1356,15 @@
   return 1;
 }
 
-int avahi_loop_with_timeout(AvahiSimplePoll *s, int retry_interval){
+int avahi_loop_with_timeout(AvahiSimplePoll *s, int retry_interval,
+			    mandos_context *mc){
   int ret;
   struct timespec now;
   struct timespec waited_time;
   intmax_t block_time;
   
   while(true){
-    if(mc.current_server == NULL){
+    if(mc->current_server == NULL){
       if (debug){
 	fprintf_plus(stderr, "Wait until first server is found."
 		     " No timeout!\n");
@@ -1345,9 +1384,9 @@
       /* Calculating in ms how long time between now and server
 	 who we visted longest time ago. Now - last seen.  */
       waited_time.tv_sec = (now.tv_sec
-			    - mc.current_server->last_seen.tv_sec);
+			    - mc->current_server->last_seen.tv_sec);
       waited_time.tv_nsec = (now.tv_nsec
-			     - mc.current_server->last_seen.tv_nsec);
+			     - mc->current_server->last_seen.tv_nsec);
       /* total time is 10s/10,000ms.
 	 Converting to s from ms by dividing by 1,000,
 	 and ns to ms by dividing by 1,000,000. */
@@ -1361,21 +1400,21 @@
       }
       
       if(block_time <= 0){
-	ret = start_mandos_communication(mc.current_server->ip,
-					 mc.current_server->port,
-					 mc.current_server->if_index,
-					 mc.current_server->af);
+	ret = start_mandos_communication(mc->current_server->ip,
+					 mc->current_server->port,
+					 mc->current_server->if_index,
+					 mc->current_server->af, mc);
 	if(ret == 0){
-	  avahi_simple_poll_quit(mc.simple_poll);
+	  avahi_simple_poll_quit(s);
 	  return 0;
 	}
 	ret = clock_gettime(CLOCK_MONOTONIC,
-			    &mc.current_server->last_seen);
+			    &mc->current_server->last_seen);
 	if(ret == -1){
 	  perror_plus("clock_gettime");
 	  return -1;
 	}
-	mc.current_server = mc.current_server->next;
+	mc->current_server = mc->current_server->next;
 	block_time = 0; 	/* Call avahi to find new Mandos
 				   servers, but don't block */
       }
@@ -1450,7 +1489,14 @@
   int numhooks = scandir(hookdir, &direntries, runnable_hook,
 			 alphasort);
   if(numhooks == -1){
-    perror_plus("scandir");
+    if(errno == ENOENT){
+      if(debug){
+	fprintf_plus(stderr, "Network hook directory \"%s\" not"
+		     " found\n", hookdir);
+      }
+    } else {
+      perror_plus("scandir");
+    }
   } else {
     int devnull = open("/dev/null", O_RDONLY);
     for(int i = 0; i < numhooks; i++){
@@ -1741,14 +1787,16 @@
 }
 
 int main(int argc, char *argv[]){
+  mandos_context mc = { .server = NULL, .dh_bits = 1024,
+			.priority = "SECURE256:!CTYPE-X.509:"
+			"+CTYPE-OPENPGP", .current_server = NULL, 
+			.interfaces = NULL, .interfaces_size = 0 };
   AvahiSServiceBrowser *sb = NULL;
   error_t ret_errno;
   int ret;
   intmax_t tmpmax;
   char *tmp;
   int exitcode = EXIT_SUCCESS;
-  char *interfaces = NULL;
-  size_t interfaces_size = 0;
   char *interfaces_to_take_down = NULL;
   size_t interfaces_to_take_down_size = 0;
   char tempdir[] = "/tmp/mandosXXXXXX";
@@ -1854,8 +1902,8 @@
 	connect_to = arg;
 	break;
       case 'i':			/* --interface */
-	ret_errno = argz_add_sep(&interfaces, &interfaces_size, arg,
-				 (int)',');
+	ret_errno = argz_add_sep(&mc.interfaces, &mc.interfaces_size,
+				 arg, (int)',');
 	if(ret_errno != 0){
 	  argp_error(state, "%s", strerror(ret_errno));
 	}
@@ -1988,25 +2036,22 @@
       }
     
       /* Lower privileges */
-      errno = 0;
-      ret = seteuid(uid);
-      if(ret == -1){
-	perror_plus("seteuid");
-      }
+      lower_privileges();
     }
   }
   
-  /* Remove empty interface names */
+  /* Remove invalid interface names (except "none") */
   {
     char *interface = NULL;
-    while((interface = argz_next(interfaces, interfaces_size,
+    while((interface = argz_next(mc.interfaces, mc.interfaces_size,
 				 interface))){
-      if(if_nametoindex(interface) == 0){
-	if(interface[0] != '\0' and strcmp(interface, "none") != 0){
+      if(strcmp(interface, "none") != 0
+	 and if_nametoindex(interface) == 0){
+	if(interface[0] != '\0'){
 	  fprintf_plus(stderr, "Not using nonexisting interface"
 		       " \"%s\"\n", interface);
 	}
-	argz_delete(&interfaces, &interfaces_size, interface);
+	argz_delete(&mc.interfaces, &mc.interfaces_size, interface);
 	interface = NULL;
       }
     }
@@ -2014,15 +2059,19 @@
   
   /* Run network hooks */
   {
-    ret_errno = argz_append(&interfaces_hooks, &interfaces_hooks_size,
-			    interfaces, interfaces_size);
-    if(ret_errno != 0){
-      errno = ret_errno;
-      perror_plus("argz_append");
-      goto end;
+    if(mc.interfaces != NULL){
+      interfaces_hooks = malloc(mc.interfaces_size);
+      if(interfaces_hooks == NULL){
+	perror_plus("malloc");
+	goto end;
+      }
+      memcpy(interfaces_hooks, mc.interfaces, mc.interfaces_size);
+      interfaces_hooks_size = mc.interfaces_size;
+      argz_stringify(interfaces_hooks, interfaces_hooks_size,
+		     (int)',');
     }
-    argz_stringify(interfaces_hooks, interfaces_hooks_size, (int)',');
-    if(not run_network_hooks("start", interfaces_hooks, delay)){
+    if(not run_network_hooks("start", interfaces_hooks != NULL ?
+			     interfaces_hooks : "", delay)){
       goto end;
     }
   }
@@ -2035,8 +2084,8 @@
      from the signal handler */
   /* Initialize the pseudo-RNG for Avahi */
   srand((unsigned int) time(NULL));
-  mc.simple_poll = avahi_simple_poll_new();
-  if(mc.simple_poll == NULL){
+  simple_poll = avahi_simple_poll_new();
+  if(simple_poll == NULL){
     fprintf_plus(stderr,
 		 "Avahi: Failed to create simple poll object.\n");
     exitcode = EX_UNAVAILABLE;
@@ -2107,7 +2156,7 @@
   }
   
   /* If no interfaces were specified, make a list */
-  if(interfaces == NULL){
+  if(mc.interfaces == NULL){
     struct dirent **direntries;
     /* Look for any good interfaces */
     ret = scandir(sys_class_net, &direntries, good_interface,
@@ -2115,7 +2164,7 @@
     if(ret >= 1){
       /* Add all found interfaces to interfaces list */
       for(int i = 0; i < ret; ++i){
-	ret_errno = argz_add(&interfaces, &interfaces_size,
+	ret_errno = argz_add(&mc.interfaces, &mc.interfaces_size,
 			     direntries[i]->d_name);
 	if(ret_errno != 0){
 	  perror_plus("argz_add");
@@ -2135,21 +2184,27 @@
     }
   }
   
-  /* If we only got one interface, explicitly use only that one */
-  if(argz_count(interfaces, interfaces_size) == 1){
-    if(debug){
-      fprintf_plus(stderr, "Using only interface \"%s\"\n",
-		   interfaces);
-    }
-    if_index = (AvahiIfIndex)if_nametoindex(interfaces);
-  }
-  
-  /* Bring up interfaces which are down */
-  if(not (argz_count(interfaces, interfaces_size) == 1
-	  and strcmp(interfaces, "none") == 0)){
+  /* Bring up interfaces which are down, and remove any "none"s */
+  {
     char *interface = NULL;
-    while((interface = argz_next(interfaces, interfaces_size,
+    while((interface = argz_next(mc.interfaces, mc.interfaces_size,
 				 interface))){
+      /* If interface name is "none", stop bringing up interfaces.
+	 Also remove all instances of "none" from the list */
+      if(strcmp(interface, "none") == 0){
+	argz_delete(&mc.interfaces, &mc.interfaces_size,
+		    interface);
+	interface = NULL;
+	while((interface = argz_next(mc.interfaces,
+				     mc.interfaces_size, interface))){
+	  if(strcmp(interface, "none") == 0){
+	    argz_delete(&mc.interfaces, &mc.interfaces_size,
+			interface);
+	    interface = NULL;
+	  }
+	}
+	break;
+      }
       bool interface_was_up = interface_is_up(interface);
       ret = bring_up_interface(interface, delay);
       if(not interface_was_up){
@@ -2163,19 +2218,25 @@
 	}
       }
     }
-    free(interfaces);
-    interfaces = NULL;
-    interfaces_size = 0;
     if(debug and (interfaces_to_take_down == NULL)){
       fprintf_plus(stderr, "No interfaces were brought up\n");
     }
   }
   
+  /* If we only got one interface, explicitly use only that one */
+  if(argz_count(mc.interfaces, mc.interfaces_size) == 1){
+    if(debug){
+      fprintf_plus(stderr, "Using only interface \"%s\"\n",
+		   mc.interfaces);
+    }
+    if_index = (AvahiIfIndex)if_nametoindex(mc.interfaces);
+  }
+  
   if(quit_now){
     goto end;
   }
   
-  ret = init_gnutls_global(pubkey, seckey);
+  ret = init_gnutls_global(pubkey, seckey, &mc);
   if(ret == -1){
     fprintf_plus(stderr, "init_gnutls_global failed\n");
     exitcode = EX_UNAVAILABLE;
@@ -2198,7 +2259,7 @@
     goto end;
   }
   
-  if(not init_gpgme(pubkey, seckey, tempdir)){
+  if(not init_gpgme(pubkey, seckey, tempdir, &mc)){
     fprintf_plus(stderr, "init_gpgme failed\n");
     exitcode = EX_UNAVAILABLE;
     goto end;
@@ -2225,21 +2286,21 @@
       goto end;
     }
     
-    uint16_t port;
+    in_port_t port;
     errno = 0;
     tmpmax = strtoimax(address+1, &tmp, 10);
     if(errno != 0 or tmp == address+1 or *tmp != '\0'
-       or tmpmax != (uint16_t)tmpmax){
+       or tmpmax != (in_port_t)tmpmax){
       fprintf_plus(stderr, "Bad port number\n");
       exitcode = EX_USAGE;
       goto end;
     }
-  
+    
     if(quit_now){
       goto end;
     }
     
-    port = (uint16_t)tmpmax;
+    port = (in_port_t)tmpmax;
     *address = '\0';
     /* Colon in address indicates IPv6 */
     int af;
@@ -2261,7 +2322,8 @@
     }
     
     while(not quit_now){
-      ret = start_mandos_communication(address, port, if_index, af);
+      ret = start_mandos_communication(address, port, if_index, af,
+				       &mc);
       if(quit_now or ret == 0){
 	break;
       }
@@ -2293,9 +2355,8 @@
     config.publish_domain = 0;
     
     /* Allocate a new server */
-    mc.server = avahi_server_new(avahi_simple_poll_get
-				 (mc.simple_poll), &config, NULL,
-				 NULL, &ret_errno);
+    mc.server = avahi_server_new(avahi_simple_poll_get(simple_poll),
+				 &config, NULL, NULL, &ret_errno);
     
     /* Free the Avahi configuration data */
     avahi_server_config_free(&config);
@@ -2316,7 +2377,8 @@
   /* Create the Avahi service browser */
   sb = avahi_s_service_browser_new(mc.server, if_index,
 				   AVAHI_PROTO_UNSPEC, "_mandos._tcp",
-				   NULL, 0, browse_callback, NULL);
+				   NULL, 0, browse_callback,
+				   (void *)&mc);
   if(sb == NULL){
     fprintf_plus(stderr, "Failed to create service browser: %s\n",
 		 avahi_strerror(avahi_server_errno(mc.server)));
@@ -2334,8 +2396,8 @@
     fprintf_plus(stderr, "Starting Avahi loop search\n");
   }
 
-  ret = avahi_loop_with_timeout(mc.simple_poll,
-				(int)(retry_interval * 1000));
+  ret = avahi_loop_with_timeout(simple_poll,
+				(int)(retry_interval * 1000), &mc);
   if(debug){
     fprintf_plus(stderr, "avahi_loop_with_timeout exited %s\n",
 		 (ret == 0) ? "successfully" : "with error");
@@ -2348,14 +2410,16 @@
   }
   
   /* Cleanup things */
+  free(mc.interfaces);
+  
   if(sb != NULL)
     avahi_s_service_browser_free(sb);
   
   if(mc.server != NULL)
     avahi_server_free(mc.server);
   
-  if(mc.simple_poll != NULL)
-    avahi_simple_poll_free(mc.simple_poll);
+  if(simple_poll != NULL)
+    avahi_simple_poll_free(simple_poll);
   
   if(gnutls_initialized){
     gnutls_certificate_free_credentials(mc.cred);
@@ -2383,7 +2447,8 @@
     raise_privileges();
     
     /* Run network hooks */
-    run_network_hooks("stop", interfaces_hooks, delay);
+    run_network_hooks("stop", interfaces_hooks != NULL ?
+		      interfaces_hooks : "", delay);
     
     /* Take down the network interfaces which were brought up */
     {

=== modified file 'plugins.d/mandos-client.xml'
--- plugins.d/mandos-client.xml	2012-06-13 22:06:57 +0000
+++ plugins.d/mandos-client.xml	2012-06-17 02:30:59 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos-client">
-<!ENTITY TIMESTAMP "2012-06-13">
+<!ENTITY TIMESTAMP "2012-06-17">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -226,9 +226,11 @@
       
       <varlistentry>
 	<term><option>--interface=<replaceable
-	>NAME</replaceable></option></term>
+	>NAME</replaceable><arg rep='repeat'>,<replaceable
+	>NAME</replaceable></arg></option></term>
 	<term><option>-i
-	<replaceable>NAME</replaceable></option></term>
+	<replaceable>NAME</replaceable><arg rep='repeat'>,<replaceable
+	>NAME</replaceable></arg></option></term>
 	<listitem>
 	  <para>
 	    Comma separated list of network interfaces that will be
@@ -237,9 +239,10 @@
 	    use all appropriate interfaces.
 	  </para>
 	  <para>
-	    If the <option>--connect</option> option is used, this
-	    specifies the interface to use to connect to the address
-	    given.
+	    If the <option>--connect</option> option is used, and
+	    exactly one interface name is specified (except
+	    <quote><literal>none</literal></quote>), this specifies
+	    the interface to use to connect to the address given.
 	  </para>
 	  <para>
 	    Note that since this program will normally run in the
@@ -254,10 +257,11 @@
 	  </para>
 	  <para>
 	    <replaceable>NAME</replaceable> can be the string
-	    <quote><literal>none</literal></quote>; this will not use
-	    any specific interface, and will not bring up an interface
-	    on startup.  This is not recommended, and only meant for
-	    advanced users.
+	    <quote><literal>none</literal></quote>; this will make
+	    <command>&COMMANDNAME;</command> not bring up
+	    <emphasis>any</emphasis> interfaces specified
+	    <emphasis>after</emphasis> this string.  This is not
+	    recommended, and only meant for advanced users.
 	  </para>
 	</listitem>
       </varlistentry>

